-- [[ Addon by Diablos | Version 2 ]] --
-- [[ SteamID64 of the buyer: 76561198299833933. Hoping you like the addon. ]] --
-- [[ BEFORE OPENING A TICKET ON GMODSTORE READ THE FAQ AT http://diabloscoder.com/faq/. ]] --
-- [[ This is the configuration file. ]] --

-- [[ /!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\      DON'T TOUCH ALL OF THIS      /!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\ ]] --
Diablos = Diablos or {}
Diablos.CS = {}
Diablos.CS.Colors = {}
Diablos.CS.Download = {}
Diablos.CS.Strings = {}
-- [[ /!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\ NOW YOU CAN EDIT THE THINGS BELOW /!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\ ]] --

-- [[ General Configuration ]] --

	Diablos.CS.Language = "english" -- Language of the script. Available languages are written at http://diabloscoder.com/languages.

	Diablos.CS.BusDriverTeam = "Bus driver" -- Name of the bus driver job. You must create it in your jobs file then put his name.

	Diablos.CS.VehiclePos = Vector(0, 0, 0) -- Position for the vehicle spawn. Type "getpos" in your client console and retrieve the three first values, then separate them with commas in the Vector() function.

	Diablos.CS.VehicleAng = Angle(0, 0, 0) -- Angle for the vehicle spawn. Type "getpos" in your client console and retrieve the three last values, then separate them with commas in the Angle() function.

	Diablos.CS.VehicleClass = "sw_bus" -- Classname of the bus vehicle (right click on the vehicle and copy to clipboard in the Q menu to have the class of a vehicle).

	Diablos.CS.VehicleSkin = 0 -- Skin of the vehicle. If you don't want to change the skin, put this value to 0.

	Diablos.CS.BusDriverSalary = 500 -- Bus driver salary received.

	Diablos.CS.TimeMoney = 0 -- Time (in minutes) between each salary the bus driver will receive. If you set this to 0, then the bus driver will receive the money after a certain amount of bus stop you configure the line below.

	Diablos.CS.AmountBusStop = 3 -- If Diablos.CS.TimeMoney is set to 0: this is the amount of bus stops to pass to receive your salary.

	Diablos.CS.BusPrice = 200 -- Price the bus driver must pay if he wants to spawn his bus vehicle. 0 to disable.

	Diablos.CS.AutoEnterVehicle = true -- true = the bus driver enters automatically in the bus when he took it on the frame.

	Diablos.CS.TicketSystem = true -- true = enable the ticket system (people enter in the bus driver then they click on a key to request a "virtual" ticket at the bus driver).

	-- [[ If Diablos.CS.TicketSystem is set to true ]] --

		Diablos.CS.TicketPrice = 10 -- Price of the ticket when a bus driver will sell one.

		Diablos.CS.TicketKey = IN_RELOAD -- Key the man must press to request a ticket (default: reload key (R)). You must put a IN enumeration, more informations at "http://wiki.garrysmod.com/page/Enums/IN".

	-- [[ End of this If ]] --

	Diablos.CS.EjectFromVehSystem = true -- true = enable an "eject from vehicle" system (the bus driver can eject people he wants from his own vehicle (this is for AFK people or those who disturbe people inside the vehicle)).

	Diablos.CS.CitybusPanelPosX = 0.5 -- CENTERED (which means 0.5 makes the citybus panel in a PERFECT center) X pos of the citybus panel. The value must be at least between 0 and 1, 0 at the left and 1 at the right.

	Diablos.CS.CitybusPanelPosY = 0.05 -- Y pos of the citybus panel. The value must be between 0 and 1, 0 at the top and 1 at the bottom.

	Diablos.CS.BusStopPanelText = "Managed by Diablos" -- If you have enough space in the bus schedule panel, this is a text written in the bottom-right. Leave empty if you don't want to write something.

	Diablos.CS.HidePanelKey = IN_ATTACK -- Key to show/hide the citybus panel. You must put a IN enumeration, more informations at "http://wiki.garrysmod.com/page/Enums/IN". Put this value to nil to remove.

	-- [[ If Diablos.CS.HidePanelKey isn't set to nil ]] --

		Diablos.CS.CitybusPanelText = "Show/hide the panel: Left Click (in your bus)" -- The text at the bottom right of the citybus panel where the key to show/hide the panel is written. "" to leave empty.

	-- [[ End of this If ]] --

	Diablos.CS.PlayersNeeded = 0 -- Number of players that the server needs to begin a bus driver mission (to avoid that the player will win money if there is nobody in the server). 0 to disable.

	Diablos.CS.Optimization = 200 -- Value for optimization. The lower the value will be, near a bus stop the player will have to be to see the bus schedule.

	Diablos.CS.NPCModel = "models/gman.mdl" -- Model of the NPC.

	Diablos.CS.NPCHeadMessage = "BUS DRIVER BOARD" -- Message ('title') above the NPC. "" to disable.

-- [[ Color Theme Configuration ]] --

	-- [[ Colors of frames related things ]] --

		Diablos.CS.Colors.Blurs = true -- true = enable blur effects (around the frames NOT in them).

		Diablos.CS.Colors.Frame = Color(50, 50, 50, 200) -- Color of the frame.

		Diablos.CS.Colors.Panel = Color(100, 100, 100, 40) -- Color of the panels in the frame.

		Diablos.CS.Colors.Header = Color(80, 140, 80, 200) -- Color of the headers.

		Diablos.CS.Colors.Buttons = Color(60, 120, 60, 150) -- Color of the buttons.

		Diablos.CS.Colors.VBarGrip = Color(40, 120, 40, 120) -- Color of the vertical bar grip.

		Diablos.CS.Colors.VBarBG = Color(75, 75, 75, 255) -- Color of the vertical bar background.

		Diablos.CS.Colors.Label = Color(220, 220, 220, 220) -- Color of the labels (text in frames).

		Diablos.CS.Colors.LabelHovered = Color(50, 50, 50, 220) -- If it's a button, color of the labels when they are in the "hovered" mode (there is the mouse on the label).

		Diablos.CS.Colors.LabelDown = Color(0, 0, 0, 220) -- If it's a button, color of the labels when they are in the "down" mode (you press left click on the label).

	-- [[ Colors of HUD / vehicle / NPC ]] --

		Diablos.CS.Colors.HUDInfos = Color(0, 255, 0, 150) -- Color of the HUD informations when you begin a bus driver mission and you have the indication of where you must go.

		Diablos.CS.Colors.Vehicle = Color(255, 255, 255, 255) -- Color of the bus driver vehicle.

		Diablos.CS.Colors.NPCHeadText = Color(230, 230, 230, 250) -- Color of the 'title' above the NPC.

		Diablos.CS.Colors.NPCHeadBorder = Color(50, 50, 50, 200) -- Color of the borders around the 'title' of the NPC.

	-- [[ Colors of the bus schedule on the bus stop ]] --

		Diablos.CS.Colors.LinesDestination = Color(100, 50, 20, 240) -- Color of lines (a bit red by default) who frame the destinations.

		Diablos.CS.Colors.BoxesIsGoing = Color(150, 100, 50, 255) -- Color of the box around a destination when a bus driver is going to this destination.

		Diablos.CS.Colors.BackgroundDestination = Color(200, 200, 200, 255) -- Color of the background of every destination (by default almost white).

		Diablos.CS.Colors.BoxesCurrent = Color(100, 200, 100, 255) -- Color of the box around the current bus stop. It's also the outline color around the bus schedule.

	-- [[ Colors of the citybus panel at the top of the screen of the bus drivers ]] --

		Diablos.CS.Colors.BackgroundAroundP = Color(70, 150, 70, 150) -- Color of the background around the citybus panel (green by default).

		Diablos.CS.Colors.BackgroundBaseP = Color(150, 150, 150, 150) -- Color of the background and the panels.

		Diablos.CS.Colors.LinesP = Color(255, 255, 255, 150) -- Color of the lines.

		Diablos.CS.Colors.LabelP = Color(0, 0, 0, 255) -- Color of the texts.

		Diablos.CS.Colors.ButtonsPause = Color(250, 50, 50, 100) -- Color of the bus pause button when the bus driver is in the "stop work state" (almost red by default).

-- [[ Content Download Configuration ]] --

	Diablos.CS.Download.FastDL = false -- true = clients install the contents via FastDL.

	Diablos.CS.Download.Workshop = true -- true = clients install the contents via Workshop.

-- [[ End of the configuration file ]] --

TPCSAExtensions() -- DO NOT DELETE THIS LINE. This line updates the language strings and some informations of the addon.