include("shared.lua")

function ENT:Draw()
	self:DrawModel()

	if Diablos.CS.NPCHeadMessage == "" then return end
	surface.SetFont("DiablosCSAboveHeadFont")
	local sizex, sizey = surface.GetTextSize(Diablos.CS.NPCHeadMessage)

	cam.Start3D2D(self:GetPos() + self:GetUp() * 85, Angle(0, LocalPlayer():EyeAngles().y-90, 90), .1)
		draw.RoundedBox(8, - sizex / 2 - 25, -10, sizex + 50, sizey + 20, Diablos.CS.Colors.NPCHeadBorder)
		draw.RoundedBox(8, - sizex / 2 - 5, 0, sizex + 10, sizey, Diablos.CS.Colors.NPCHeadBorder)
		draw.SimpleText(Diablos.CS.NPCHeadMessage, "DiablosCSAboveHeadFont", 0, 0, Diablos.CS.Colors.NPCHeadText, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
	cam.End3D2D()
end

local function DiablosCSPaintButtons(panel)
	if panel.Hovered then
		if panel:IsDown() then
			panel:SetTextColor(Diablos.CS.Colors.LabelDown)
		else
			panel:SetTextColor(Diablos.CS.Colors.LabelHovered)
		end
	else
		panel:SetTextColor(Diablos.CS.Colors.Label)
	end
end

local col = {
	pre1 = Color(200, 40, 40),
	pre2 = Color(100, 255, 100),
	rndbox = Color(100, 100, 100, 100),
}

local function TPCSAAdminFrame(ent)
	local valident = IsValid(ent)

	local frame = vgui.Create("DFrame")
	frame:SetSize(300, 190)
	frame:Center()
	frame:SetTitle("")
	frame:ShowCloseButton(false)
	frame.Paint = function(s, w, h)
		if Diablos.CS.Colors.Blurs then Derma_DrawBackgroundBlur(s, 1) end
		surface.SetDrawColor(Diablos.CS.Colors.Frame) surface.DrawRect(0, 0, w, h)
		surface.SetDrawColor(Diablos.CS.Colors.Header) surface.DrawRect(0, 0, w, 30)
		draw.SimpleText("ADMIN BUS STOP CONFIGURATION", "DiablosCSMainFont", 7, 7, Diablos.CS.Colors.Label, TEXT_ALIGN_LEFT, TEXT_ALIGN_LEFT)
		draw.SimpleText("NAME:", "DiablosCSMainFont", 20, 55, Diablos.CS.Colors.Label, TEXT_ALIGN_LEFT, TEXT_ALIGN_LEFT)
	end

	frame:MakePopup()

	local cancel = vgui.Create("DButton", frame)
	cancel:SetPos(280, 5)
	cancel:SetSize(20, 20)
	cancel:SetText("X")
	cancel:SetFont("DiablosCSMainFont")
	cancel.DoClick = function()
		frame:Close()
	end
	cancel.Paint = function(s, w, h)
		DiablosCSPaintButtons(s)
	end

	local name = vgui.Create("DTextEntry", frame)
	name:SetPos(120, 50)
	name:SetSize(160, 30)
	name:SetFont("DiablosCSMainFont")
	name.Paint = function(s, w, h)
		surface.SetDrawColor(col.rndbox) surface.DrawRect(0, 0, w, h)
		s:DrawTextEntryText(Diablos.CS.Colors.Label, Diablos.CS.Colors.LabelHovered, Diablos.CS.Colors.LabelDown)
	end

	local order = vgui.Create("DButton", frame)
	order:SetPos(50, 100)
	order:SetSize(200, 30)
	order:SetText("CONFIGURE BUS STOP ORDER")
	order:SetFont("DiablosCSMainFont")
	order.DoClick = function()
		LocalPlayer():ConCommand("diablos_citybusconfig")
	end
	order.Paint = function(s, w, h)
		surface.SetDrawColor(Diablos.CS.Colors.Buttons) surface.DrawRect(0, 0, w, h)
		DiablosCSPaintButtons(s)
	end

	if not valident then name:SetValue("BUS STOP NAME") else name:SetValue(ent:GetNameBusStop()) end

	local posx = 100
	if valident then
		posx = 25
		local delete = vgui.Create("DButton", frame)
		delete:SetPos(175, 150)
		delete:SetSize(100, 30)
		delete:SetText("DELETE")
		delete:SetFont("DiablosCSMainFont")
		delete.DoClick = function()
			net.Start("TPCSA:Save")
				net.WriteEntity(ent)
				net.WriteString(name:GetValue())
				net.WriteBool(false)
			net.SendToServer()
			frame:Close()
		end
		delete.Paint = function(s, w, h)
			surface.SetDrawColor(Diablos.CS.Colors.Buttons) surface.DrawRect(0, 0, w, h)
			DiablosCSPaintButtons(s)
		end
	end

	local save = vgui.Create("DButton", frame)
	save:SetPos(posx, 150)
	save:SetSize(100, 30)
	save:SetText("SAVE")
	save:SetFont("DiablosCSMainFont")
	save.DoClick = function()
		net.Start("TPCSA:Save")
			net.WriteEntity(ent)
			net.WriteString(name:GetValue())
			net.WriteBool(true)
		net.SendToServer()
		frame:Close()
	end
	save.Paint = function(s, w, h)
		surface.SetDrawColor(Diablos.CS.Colors.Buttons) surface.DrawRect(0, 0, w, h)
		DiablosCSPaintButtons(s)
	end
end

local function TPCSAConfigFrame(bustab)

	local ply = LocalPlayer()

	local frame = vgui.Create("DFrame")
	frame:SetSize(500, 600)
	frame:Center()
	frame:ShowCloseButton(false)
	frame:SetTitle("")
	frame.Paint = function(s, w, h)
		if Diablos.CS.Colors.Blurs then Derma_DrawBackgroundBlur(s, 1) end
		surface.SetDrawColor(Diablos.CS.Colors.Frame) surface.DrawRect(0, 0, w, h)
		surface.SetDrawColor(Diablos.CS.Colors.Header) surface.DrawRect(0, 0, w, 30)
		draw.SimpleText("CONFIGURE THE BUS STOPS ORDER", "DiablosCSMainFont", 7, 7, Diablos.CS.Colors.Label, TEXT_ALIGN_LEFT, TEXT_ALIGN_LEFT)
		if bustab[1] != "" then
			draw.SimpleText("NAME", "DiablosCSMainFont", 110, 45, Diablos.CS.Colors.Label, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
			draw.SimpleText("ORDER", "DiablosCSMainFont", 260, 45, Diablos.CS.Colors.Label, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
		else
			draw.SimpleText("0 bus stops found.", "DiablosCSMainFont", 240, 300, Diablos.CS.Colors.Label, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
		end
	end

	frame:MakePopup()

	local cancel = vgui.Create("DButton", frame)
	cancel:SetPos(480, 5)
	cancel:SetSize(20, 20)
	cancel:SetText("X")
	cancel:SetFont("DiablosCSMainFont")
	cancel.DoClick = function()
		frame:Close()
	end
	cancel.Paint = function(s, w, h)
		DiablosCSPaintButtons(s)
	end

	if bustab[1] != "" then
		local scroll = vgui.Create("DScrollPanel", frame)
		scroll:SetPos(10, 80)
		scroll:SetSize(480, 450)

		local scrollvbar = scroll:GetVBar()

		scrollvbar.Paint = function(s, w, h)
			draw.RoundedBox(4, 5, 0, 10, h, Diablos.CS.Colors.VBarBG)
		end
		
		scrollvbar.btnGrip.Paint = function(s, w, h)
			draw.RoundedBox(8, 5, 0, 10, h, Diablos.CS.Colors.VBarGrip)
		end
		
		scrollvbar.btnUp.Paint = function(s, w, h) end
		scrollvbar.btnDown.Paint = function(s, w, h) end

		for num, v in pairs(bustab) do
			if #v <= 1 then return end
			local ex = string.Explode(";", v)

			local buspanel = vgui.Create("DPanel", scroll)
			buspanel:SetPos(0, (num - 1) * 35)
			buspanel:SetSize(465, 30)
			buspanel.Paint = function(s, w, h)
				surface.SetDrawColor(Diablos.CS.Colors.Panel) surface.DrawRect(0, 0, w, h)
				draw.SimpleText(string.sub(ex[1], 2), "DiablosCSMainFont", 100, 5, Diablos.CS.Colors.Label, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
				draw.SimpleText(num, "DiablosCSMainFont", 250, 5, Diablos.CS.Colors.Label, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
			end

			if num != 1 then
				local busup = vgui.Create("DButton", buspanel)
				busup:SetPos(410, 5)
				busup:SetSize(15, 15)
				busup:SetFont("DiablosCSMainFont")
				busup:SetTextColor(Diablos.CS.Colors.Label)
				busup:SetText("▲")
				busup.DoClick = function()
					net.Start("TPCSA:SaveOrder")
						net.WriteBool(false)
						net.WriteUInt(num, 8)
						net.WriteUInt(num - 1, 8)
					net.SendToServer()
					frame:Close()
					ply:ConCommand("diablos_citybusconfig")
				end
				busup.Paint = function(s, w, h)
					DiablosCSPaintButtons(s)
				end
			end

			if num < #bustab - 1 then
				local busdown = vgui.Create("DButton", buspanel)
				busdown:SetPos(430, 5)
				busdown:SetSize(15, 15)
				busdown:SetFont("DiablosCSMainFont")
				busdown:SetTextColor(Diablos.CS.Colors.Label)
				busdown:SetText("▼")
				busdown.DoClick = function()
					net.Start("TPCSA:SaveOrder")
						net.WriteBool(false)
						net.WriteUInt(num, 8)
						net.WriteUInt(num + 1, 8)
					net.SendToServer()
					frame:Close()
					ply:ConCommand("diablos_citybusconfig")
				end
				busdown.Paint = function(s, w, h)
					DiablosCSPaintButtons(s)
				end
			end

			local busremove = vgui.Create("DButton", buspanel)
			busremove:SetPos(450, 5)
			busremove:SetSize(15, 15)
			busremove:SetFont("DiablosCSMainFont")
			busremove:SetTextColor(Diablos.CS.Colors.Label)
			busremove:SetText("x")
			busremove.DoClick = function()
				net.Start("TPCSA:SaveOrder")
					net.WriteBool(true)
					net.WriteUInt(num, 8)
					net.WriteUInt(0, 8)
				net.SendToServer()
				frame:Close()
				ply:ConCommand("diablos_citybusconfig")
			end
			busremove.Paint = function(s, w, h)
				DiablosCSPaintButtons(s)
			end

			scroll:AddItem(buspanel)
		end
	end
end

local function TPCSABusFrame()

	local earncondition = Diablos.CS.Strings.earn .. " " .. GAMEMODE.Config.currency .. Diablos.CS.BusDriverSalary .. " "
	if Diablos.CS.TimeMoney != 0 then
		earncondition = earncondition .. Diablos.CS.Strings.all .. " " .. Diablos.CS.TimeMoney .. " " .. Diablos.CS.Strings.minute
	else
		earncondition = earncondition .. Diablos.CS.Strings.all2 .. " " .. Diablos.CS.AmountBusStop .. " " .. Diablos.CS.Strings.busstops
	end

	local frame = vgui.Create("DFrame")
	frame:SetSize(600, 150)
	frame:Center()
	frame:SetTitle("")
	frame:SetDraggable(false)
	frame:ShowCloseButton(false)
	frame.Paint = function(s, w, h)
		if Diablos.CS.Colors.Blurs then Derma_DrawBackgroundBlur(s, 1) end
		surface.SetDrawColor(Diablos.CS.Colors.Frame) surface.DrawRect(0, 0, w, h)
		surface.SetDrawColor(Diablos.CS.Colors.Header) surface.DrawRect(0, 0, w, 30)
		draw.SimpleText(Diablos.CS.Strings.takeabus, "DiablosCSMainFont", 7, 7, Diablos.CS.Colors.Label, TEXT_ALIGN_LEFT, TEXT_ALIGN_LEFT)
		draw.SimpleText(earncondition .. ".", "DiablosCSMainFont", 300, 50, Diablos.CS.Colors.Label, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
		draw.SimpleText(Diablos.CS.Strings.bringvehicle .. ".", "DiablosCSMainFont", 300, 75, Diablos.CS.Colors.Label, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
	end

	frame:MakePopup()

	local cancel = vgui.Create("DButton", frame)
	cancel:SetPos(580, 5)
	cancel:SetSize(20, 20)
	cancel:SetText("X")
	cancel:SetFont("DiablosCSMainFont")
	cancel.DoClick = function()
		frame:Close()
	end
	cancel.Paint = function(s, w, h)
		DiablosCSPaintButtons(s)
	end

	local missionapply = vgui.Create("DButton", frame)
	missionapply:SetPos(100, 110)
	missionapply:SetSize(400, 30)
	if Diablos.CS.BusPrice == 0 then
		missionapply:SetText(Diablos.CS.Strings.takemybus)
	else
		missionapply:SetText(Diablos.CS.Strings.takemybus .. " (" .. GAMEMODE.Config.currency .. Diablos.CS.BusPrice .. ")")
	end
	missionapply:SetFont("DiablosCSMainFont")
	missionapply.Paint = function(s, w, h)
		surface.SetDrawColor(Diablos.CS.Colors.Buttons) surface.DrawRect(0, 0, w, h)
		DiablosCSPaintButtons(s)
	end

	missionapply.DoClick = function()
		frame:Close()
		net.Start("TPCSA:Mission")
		net.SendToServer()
	end
end

local origin = Vector(0, 0, 0)
local ent
local seehud = false

local function TPCSABusHUD(entity, bool)
	ent = entity
	seehud = bool
	if IsValid(ent) then
		origin = ent:GetPos()
	else
		origin = Diablos.CS.VehiclePos
	end
end

local mainpanel
local plystate = false


local function TPCSAPanel(viewstate, tabplyinveh, tabbusticket)
	if ispanel(mainpanel) then mainpanel:Remove() end
	if not viewstate then return end
	local ply = LocalPlayer()
	local vehloc = ply:GetVehicle()

	local scrw, scrh = ScrW(), ScrH()

	local numbusticket, numplyinveh = table.Count(tabbusticket), table.Count(tabplyinveh)

	if numplyinveh == 1 and tabplyinveh[1] == 0 then
		plystate = false
		return 
	end

	local mainsizex = 320
	if Diablos.CS.EjectFromVehSystem and Diablos.CS.TicketSystem then mainsizex = 600 end

	mainpanel = vgui.Create("DPanel")
	mainpanel:SetPos(scrw * Diablos.CS.CitybusPanelPosX - mainsizex / 2, scrh * Diablos.CS.CitybusPanelPosY)
	mainpanel:SetSize(mainsizex, 300)
	mainpanel.Paint = function(s, w, h)
		draw.RoundedBox(8, 0, 0, w, h, Diablos.CS.Colors.BackgroundAroundP)
		draw.RoundedBox(8, 20, 20, w - 40, h - 40, Diablos.CS.Colors.BackgroundBaseP)
		draw.SimpleText(Diablos.CS.Strings.citybussystem, "DiablosCSMainFont", w / 2, 22, Diablos.CS.Colors.LabelP, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
		surface.SetDrawColor(Diablos.CS.Colors.LinesP) surface.DrawRect(20, 40, w - 40, 2)
		surface.SetDrawColor(Diablos.CS.Colors.LinesP) surface.DrawRect(20, 242, w - 40, 3)
		if not Diablos.CS.EjectFromVehSystem and not Diablos.CS.TicketSystem then
			draw.SimpleText(Diablos.CS.Strings.nocitybuspanel, "DiablosCSMainFont", 160, 150, Diablos.CS.Colors.LabelP, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
		else
			if Diablos.CS.EjectFromVehSystem and Diablos.CS.TicketSystem then
				surface.SetDrawColor(Diablos.CS.Colors.LinesP) surface.DrawRect(299, 42, 2, 200)
				
				draw.SimpleText(Diablos.CS.Strings.peopleinbus, "DiablosCSMainFont", 160, 40, Diablos.CS.Colors.LabelP, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
				if numplyinveh == 0 then
					draw.SimpleText(Diablos.CS.Strings.nobodyinbus, "DiablosCSMainFont", 160, 140, Diablos.CS.Colors.LabelP, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
				end
				draw.SimpleText(Diablos.CS.Strings.peoplewantticket, "DiablosCSMainFont", 440, 40, Diablos.CS.Colors.LabelP, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
				if numbusticket == 0 then
					draw.SimpleText(Diablos.CS.Strings.nobodyrequests, "DiablosCSMainFont", 440, 140, Diablos.CS.Colors.LabelP, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
				end	
			else
				if Diablos.CS.EjectFromVehSystem then
					draw.SimpleText(Diablos.CS.Strings.peopleinbus, "DiablosCSMainFont", 160, 40, Diablos.CS.Colors.LabelP, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
					if numplyinveh == 0 then
						draw.SimpleText(Diablos.CS.Strings.nobodyinbus, "DiablosCSMainFont", 160, 140, Diablos.CS.Colors.LabelP, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
					end
				end
				if Diablos.CS.TicketSystem then
					draw.SimpleText(Diablos.CS.Strings.peoplewantticket, "DiablosCSMainFont", 160, 40, Diablos.CS.Colors.LabelP, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
					if numbusticket == 0 then
						draw.SimpleText(Diablos.CS.Strings.nobodyrequests, "DiablosCSMainFont", 160, 140, Diablos.CS.Colors.LabelP, TEXT_ALIGN_CENTER, TEXT_ALIGN_LEFT)
					end
				end
			end
		end
		draw.SimpleText(Diablos.CS.CitybusPanelText, "DiablosCSMainFont", w - 20, 280, Diablos.CS.Colors.LabelP, TEXT_ALIGN_RIGHT, TEXT_ALIGN_LEFT)
	end

	local pausebutton = vgui.Create("DButton", mainpanel)
	pausebutton:SetPos(20, 245)
	pausebutton:SetSize(mainsizex - 40, 35)
	pausebutton:SetFont("DiablosCSMainFont")
	pausebutton:SetText(Diablos.CS.Strings.takebuspause)
	pausebutton.DoClick = function()
		plystate = !plystate
		net.Start("TPCSA:Pause")
			net.WriteBool(plystate)
		net.SendToServer()
	end
	pausebutton.Paint = function(s, w, h)
		if plystate then
			surface.SetDrawColor(Diablos.CS.Colors.ButtonsPause)
		else
			surface.SetDrawColor(Diablos.CS.Colors.Buttons)
		end
		surface.DrawRect(0, 0, w, h)
		DiablosCSPaintButtons(s)
	end

	local labelui, labelvi = "76561198299833933", "2.0.0"
	local invehposx, invehsizex, ticketposx, ticketsizex = 0, 0, 0, 0
	if Diablos.CS.EjectFromVehSystem or Diablos.CS.TicketSystem then
		if Diablos.CS.EjectFromVehSystem and Diablos.CS.TicketSystem then
			invehposx, invehsizex, ticketposx, ticketsizex  = 30, 260, 310, 260
		else
			if Diablos.CS.EjectFromVehSystem then
				invehposx, invehsizex = 30, 260
			else
				ticketposx, ticketsizex = 30, 260
			end
		end
	else
		return
	end

	if numplyinveh != 0 then
		local scrollinveh = vgui.Create("DScrollPanel", mainpanel)
		scrollinveh:SetPos(invehposx, 60)
		scrollinveh:SetSize(invehsizex, 180)

		local scrollinvehvbar = scrollinveh:GetVBar()

		scrollinvehvbar.Paint = function(s, w, h)
			draw.RoundedBox(4, 5, 0, 10, h, Diablos.CS.Colors.VBarBG)
		end
		
		scrollinvehvbar.btnGrip.Paint = function(s, w, h)
			draw.RoundedBox(8, 5, 0, 10, h, Diablos.CS.Colors.VBarGrip)
		end
		
		scrollinvehvbar.btnUp.Paint = function(s, w, h) end
		scrollinvehvbar.btnDown.Paint = function(s, w, h) end

		for k,v in pairs(tabplyinveh) do
			local panelinveh = vgui.Create("DPanel", scrollinveh)
			panelinveh:SetPos(0, (k - 1) * 30)
			panelinveh:SetSize(invehsizex - 20, 25)
			panelinveh.Paint = function(s, w, h)
				draw.RoundedBox(2, 0, 0, w, h, Diablos.CS.Colors.BackgroundBaseP)
				draw.RoundedBox(2, 0, h - 2, w, 2, Diablos.CS.Colors.LinesP)
				local thingtosay
				if IsValid(v) then thingtosay = v:Nick() else thingtosay = Diablos.CS.Strings.invalidplayer end
				draw.SimpleText(thingtosay, "DiablosCSMainFont", 5, 2, Diablos.CS.Colors.LabelP, TEXT_ALIGN_LEFT, TEXT_ALIGN_LEFT)
			end

			local buttonpanelinveh = vgui.Create("DButton", panelinveh)
			buttonpanelinveh:SetPos(invehsizex - 100, 0)
			buttonpanelinveh:SetSize(80, 25)
			buttonpanelinveh:SetText(Diablos.CS.Strings.eject)
			buttonpanelinveh.DoClick = function()
				net.Start("TPCSA:Eject")
					net.WriteEntity(v)
				net.SendToServer()
			end
			buttonpanelinveh.Paint = function(s, w, h)
				surface.SetDrawColor(Diablos.CS.Colors.Buttons) surface.DrawRect(0, 0, w, h)
				DiablosCSPaintButtons(s)
			end
		end
	end

	if numbusticket != 0 then
		local scrollbusticket = vgui.Create("DScrollPanel", mainpanel)
		scrollbusticket:SetPos(ticketposx, 60)
		scrollbusticket:SetSize(ticketsizex, 180)

		local scrollbusticketvbar = scrollbusticket:GetVBar()

		scrollbusticketvbar.Paint = function(s, w, h)
			draw.RoundedBox(4, 5, 0, 10, h, Diablos.CS.Colors.VBarBG)
		end
		
		scrollbusticketvbar.btnGrip.Paint = function(s, w, h)
			draw.RoundedBox(8, 5, 0, 10, h, Diablos.CS.Colors.VBarGrip)
		end
		
		scrollbusticketvbar.btnUp.Paint = function(s, w, h) end
		scrollbusticketvbar.btnDown.Paint = function(s, w, h) end

		local valincr = 0
		for k,v in pairs(tabbusticket) do
			local panelbusticket = vgui.Create("DPanel", scrollbusticket)
			panelbusticket:SetPos(0, valincr * 30)
			panelbusticket:SetSize(ticketsizex - 20, 25)
			panelbusticket.Paint = function(s, w, h)
				draw.RoundedBox(2, 0, 0, w, h, Diablos.CS.Colors.BackgroundBaseP)
				draw.RoundedBox(2, 0, h - 2, w, 2, Diablos.CS.Colors.LinesP)
				local thingtosay
				if IsValid(k) then thingtosay = k:Nick() else thingtosay = Diablos.CS.Strings.invalidplayer end
				draw.SimpleText(thingtosay, "DiablosCSMainFont", 5, 2, Diablos.CS.Colors.LabelP, TEXT_ALIGN_LEFT, TEXT_ALIGN_LEFT)
			end

			local buttonpanelbusticket = vgui.Create("DButton", panelbusticket)
			buttonpanelbusticket:SetPos(ticketsizex - 100, 0)
			buttonpanelbusticket:SetSize(80, 25)
			buttonpanelbusticket:SetText(Diablos.CS.Strings.giveticket)
			buttonpanelbusticket.DoClick = function()
				net.Start("TPCSA:Ticket")
					net.WriteEntity(k)
				net.SendToServer()
			end
			buttonpanelbusticket.Paint = function(s, w, h)
				surface.SetDrawColor(Diablos.CS.Colors.Buttons)
				surface.DrawRect(0, 0, w, h)
				DiablosCSPaintButtons(s)
			end
			valincr = valincr + 1
		end
	end
end

net.Receive("TPCSA:AdminVGUI", function(len, ply) TPCSAAdminFrame(net.ReadEntity()) end)
net.Receive("TPCSA:ConfigVGUI", function(len, ply) TPCSAConfigFrame(net.ReadTable()) end)
net.Receive("TPCSA:BusVGUI", TPCSABusFrame)
net.Receive("TPCSA:BusHUD", function(len, ply) TPCSABusHUD(net.ReadEntity(), net.ReadBool()) end)
net.Receive("TPCSA:Panel", function(len, ply) TPCSAPanel(net.ReadBool(), net.ReadTable(), net.ReadTable()) end)

local function drawCircle(x, y, radius, seg)
	local cir = {}

	table.insert(cir, { x = x, y = y, u = 0.5, v = 0.5 })
	for i = 0, seg do
		local a = math.rad((i / seg) * -360)
		table.insert(cir, { x = x + math.sin(a) * radius, y = y + math.cos(a) * radius, u = math.sin(a) / 2 + 0.5, v = math.cos(a) / 2 + 0.5 })
	end

	local a = math.rad(0)
	table.insert(cir, { x = x + math.sin(a) * radius, y = y + math.cos(a) * radius, u = math.sin(a) / 2 + 0.5, v = math.cos(a) / 2 + 0.5 })

	surface.DrawPoly(cir)
end

hook.Add("HUDPaint", "TPCSA:HUDHook", function()
	if not seehud then return end
	local ply = LocalPlayer()
	if not ply:InVehicle() then return end

	local tpos = origin + Vector(0, 0, 10)
	local dist = LocalPlayer():GetShootPos():Distance(tpos)
	local spos = tpos:ToScreen()

	if !spos then return end

	render.SuppressEngineLighting(true)

	if IsValid(ent) then
		draw.DrawText(Diablos.CS.Strings.destination .. " " .. ent:GetNameBusStop() .. "\n" .. Diablos.CS.Strings.distance .. " " .. math.Round(math.floor(dist) / 40) .. "m", "DiablosCSMainFont", spos.x, spos.y, Diablos.CS.Colors.HUDInfos, TEXT_ALIGN_CENTER)
	else
		draw.DrawText(Diablos.CS.Strings.stopyourwork .. ":\n" .. Diablos.CS.Strings.distance .. " " .. math.Round(math.floor(dist) / 40) .. "m", "DiablosCSMainFont", spos.x, spos.y, Diablos.CS.Colors.HUDInfos, TEXT_ALIGN_CENTER)
	end

	surface.SetDrawColor(Diablos.CS.Colors.HUDInfos)
	draw.NoTexture()
	drawCircle(spos.x, spos.y + 70, 20, 8)

	render.SuppressEngineLighting(false)
end)

hook.Add("HUDPaint", "TPCSA:AdminHUDHook", function()
	local ply = LocalPlayer()
	if not IsValid(ply) or not ply:IsSuperAdmin() then return end
	if IsValid(ply:GetActiveWeapon()) and ply:GetActiveWeapon():GetClass() != "gmod_tool" then return end
	if istable(ply:GetTool()) and ply:GetTool().Mode != "busstop" then return end

	local globtab = ents.FindByClass("bus_stop")
	for k, ent in pairs(globtab) do
		local tpos = ent:GetPos() + Vector(0, 0, 10)
		local spos = tpos:ToScreen()

		if !spos then return end

		local id = ent:GetIDBusStop()

		render.SuppressEngineLighting(true)

		draw.DrawText("ID: " .. id, "DiablosCSMainFont", spos.x, spos.y, Diablos.CS.Colors.HUDInfos, TEXT_ALIGN_CENTER)

		surface.SetDrawColor(Diablos.CS.Colors.HUDInfos)
		draw.NoTexture()
		drawCircle(spos.x, spos.y + 50, 20, 8)

		render.SuppressEngineLighting(false)

		if IsValid(globtab[k+1]) then
			local tpose = globtab[k+1]:GetPos() + Vector(0, 0, 10)
			local spose = tpose:ToScreen()
			surface.DrawLine(spos.x, spos.y, spose.x, spose.y)
		end
	end
end)