AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include("shared.lua")

function ENT:Initialize()
	self:SetModel(Diablos.CS.NPCModel)
	self:SetHullType(HULL_HUMAN)
	self:SetHullSizeNormal()
	self:SetNPCState(NPC_STATE_SCRIPT)
	self:CapabilitiesAdd(CAP_ANIMATEDFACE, CAP_TURN_HEAD)
	self:DropToFloor()
	self:SetUseType(SIMPLE_USE)
	self:SetSolid(SOLID_BBOX)
end

function ENT:SpawnFunction(ply, tr, classname)
	if !tr.Hit then return end
	local SpawnPos = tr.HitPos + tr.HitNormal * 16
	local ent = ents.Create(classname)
	ent:SetPos(SpawnPos)
	ent:Spawn()
	ent:Activate()
	return ent
end

function ENT:AcceptInput(event, act, ply)
	if event == "Use" and IsValid(ply) and ply:IsPlayer() then
		if Diablos.CS.PlayersNeeded > player.GetCount() then
			DarkRP.notify(ply, 1, 5, Diablos.CS.Strings.notenoughplayers)
			return
		end
		if IsValid(ply.veh) and ply.veh:IsVehicle() then
			DarkRP.notify(ply, 1, 5, Diablos.CS.Strings.arentauthorize)
			return
		end
		if team.GetName(ply:Team()) == Diablos.CS.BusDriverTeam then
			self:EmitSound("vo/coast/odessa/nlo_cub_hello.wav")
			net.Start("TPCSA:BusVGUI")
			net.Send(ply)
		else
			DarkRP.notify(ply, 1, 5, Diablos.CS.Strings.arentauthorize)
		end
	end
end